<?php

//可跨域
header('Access-Control-Allow-Origin:*');
header('Access-Control-Allow-Credentials:true');
header('Access-Control-Allow-Methods:GET, POST, OPTIONS');
header("Content-type:text/html;charset=utf-8");
class WX_NativePay{

	/* *
	*	构造
	* * * * *
	*/
	public function __construct(){
	}


	/* *
	*	支付页面
	* * * * *
	*/
	public function wx_pay_page(){
		//包含微信支付按钮的页面
	}


	/* *
	*	支付完成后跳转的页面
	* * * * *
	*/
	public function wx_pay_finish_page(){
		//在此构建支付完成后的逻辑与页面
	}


	/* *
	*	创建微信H5支付请求
	*	input:
	*	$request_info = array(
	*		"out_trade_no"	=>	'用户订单ID',
	*		"total_fee"		=>	'交易金额',
	*		"body"			=>	'订单描述',
	*	);
	* * * * *
	*/
	public function create_wx_NativePay_request(){
		$status = 0;
		$msg = '';
		$redirect_url = "http://xxx.xxx.com/wx_pay_finish_page"; //微信支付成功后跳转的页面地址，必须带http://，可留空
		$request_str = array();
		$nonce_str = rand_code();	//生成随机字符串
        $data = array(
			$appid ='wxdbc5dc*******';		//appid
			$mch_id = '1493*****' ;			//商户号
			$body = "H5支付测试";			//微信支付描述，可以为空
			$spbill_create_ip = getIp();	//ip地址
			$total_fee = 1;                 //金额
			$out_trade_no = time().mt_rand(10000, 99999);   //商户订单号,不能重复
			$nonce_str = $nonce_str;						//随机字符串
			$notify_url = 'http://xxx.xxx.com/wx_notify_recharge';   //回调地址，用户接收支付后的通知，必须为能直接访问的网址，不能跟参数
			$trade_type = 'NATIVE';			//支付方式
        );
        //将参与签名的数据保存到数组  注意：以上几个参数是追加到$data中的
		//$data中应该同时包含开发文档中要求必填的剔除sign以外的所有数据
		$data['sign'] = $this->getSign($data);	//获取签名
		$xml = \ToXml($data);					//数组转xml
		$url = "https://api.mch.weixin.qq.com/pay/unifiedorder"; //微信支付接口地址
		//curl 传递给微信方
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		if (stripos($url, 'https://') !== false) {
			curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
		} else {
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);		//严格校验
		}
		//设置header
		curl_setopt($ch, CURLOPT_SSLVERSION, CURL_SSLVERSION_TLSv1);
		curl_setopt($ch, CURLOPT_HEADER, false);
		//要求结果为字符串且输出到屏幕上
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		//设置超时
		curl_setopt($ch, CURLOPT_TIMEOUT, 30);
		curl_setopt($ch, CURLOPT_POST, true);
		//传输文件
		curl_setopt($ch, CURLOPT_POSTFIELDS, $xml);
		//运行curl
		$data = curl_exec($ch);

		//返回结果
		if ($data) {
            curl_close($ch);
            $request_str = \FromXml($data);
            if ($request_str['return_code'] != 'SUCCESS') {
                $msg = '签名失败';
                return -1;
            } else {
                $sign = $this->getSign($request_str, $payment_method);
                $request_str['sign'] = $sign;
				$code_url = $request_str['code_url'];
				//生成二维码图片
				$request_str['ewm_thumb'] = $this->scerweima($code_url);
            }
        } else {
            $error = curl_errno($ch);
            curl_close($ch);
            $msg = 'curl出错，错误码:' . $error;
            return -1;
        }
        return 0;

		END:
		curl_close($ch);
		$result_info = array(
			'status'	=>	$status,
			'msg'		=>	$msg,
			'data'		=>	$request_str,
		);
		echo json_encode($result_info);
	}


	/* *
	*	微信pay - 生成签名
	* * * * *
	*/
	private function getSign($params){
		$key = "";	//key是在商户平台API安全里自己设置的，设置路径：微信商户平台(pay.weixin.qq.com)-->账户设置-->API安全-->密钥设置
		ksort($params);         //将参数数组按照参数名ASCII码从小到大排序
		foreach ($params as $k => $item) {
			//剔除参数值为空的参数
			if (!empty($item)) {
				$newArr[] = $k.'='.$item;       // 整合新的参数数组
			}
		}
		$stringA = implode('&', $newArr);         //使用 & 符号连接参数
		$stringSignTemp = $stringA.'&key='.$key;        //拼接key
		$stringSignTemp = md5($stringSignTemp);       //将字符串进行MD5加密
		$sign = strtoupper($stringSignTemp);      //将所有字符转换为大写
		return $sign;
	}


	/* *
	*	微信移动支付 回调
	*   
	* * * * *
	*/
	public function wx_notify_recharge(){
		$log_address = './log/';	//日志存储路径，目录下包含error目录，所有目录必须可写
		$xmlData = file_get_contents('php://input');	//接收微信返回的数据数据,返回的xml格式
		$filename = date('Ymd', time()).".txt";
		if ($xmlData == '') {
			$file = fopen($log_address.'error/'.$filename, 'a+');
			fwrite($file, "错误信息：未接收到参数\r\n");
			$msg = 'fail';
			goto END;
		}
		//将xml格式转换为数组
		$data = FromXml($xmlData);
		//用日志记录检查数据是否接受成功，验证成功一次之后，可删除。
		/******/
		$file = fopen($log_address.$filename, 'a+');
		fwrite($file, var_export($data, true));		//这个日志包含微信返回的所有参数！！！
		/******/
		//为了防止假数据，验证签名是否和返回的一样。
		//记录一下，返回回来的签名，生成签名的时候，必须剔除sign字段。
		$sign = $data['sign'];
		unset($data['sign']);
		if ($sign == $this->getSign($data)) {
			//签名验证成功后，判断返回微信返回的
			if ($data['result_code'] == 'SUCCESS') {
				//自定义逻辑区，根据返回的订单号做业务逻辑
				$sale_order_info = array();
				$out_trade_no = $data['out_trade_no']; //用户之前传给微信的订单号
				if (/*用户逻辑处理结果 && */ array_key_exists('sale_order_id', $sale_order_info)) {
					//处理完成之后，告诉微信成功！
					$msg = '<xml><return_code><![CDATA[SUCCESS]]></return_code><return_msg><![CDATA[OK]]></return_msg></xml>';
					goto END;
				}
			} else {
				//支付失败，输出错误信息
				$file = fopen($log_address.'error/'.$filename, 'a+');
				fwrite($file, '错误信息：'.$data['return_msg'].date('Y-m-d H:i:s'), time()."\r\n");
				$msg = 'fail';
				goto END;
			}
		} else {
			$file = fopen($log_address.'error/'.$filename, 'a+');
			fwrite($file, '错误信息：签名验证失败'.date('Y-m-d H:i:s'), time()."\r\n");
			$msg = 'fail';
			goto END;
		}
		END:
		echo $msg;
	}


	//生成二维码，需引入qrcode插件，请到博客中下载
	private function scerweima($url = ''){
		require_once 'qrcode.php';
		$value = $url;
		$errorCorrectionLevel = 'L';
		$matrixPointSize = 5;
		$year_month = date('Ym', time());
		$day = date('d', time());
		$filepath = 'navite_ewm/'.$year_month.'/'.$day;
		if(!is_dir($filepath)){
			mkdir($filepath, 0777, true);
		}
		$filename = $filepath.'/'.rand(1,10000).time().rand(1,10000).'.png';
		QRcode::png($value,$filename , $errorCorrectionLevel, $matrixPointSize, 2);
		return $filename;
	}

}


/* *
*	数组转Xml
* * * * *
*/
function ToXml($data=array()){
	if(!is_array($data) || count($data) <= 0){
		return '数组异常';
	}
	$xml = "<xml>";
	foreach($data as $key=>$val){
		if(is_numeric($val)){
			$xml.="<".$key.">".$val."</".$key.">";
		}else{
			$xml.="<".$key."><![CDATA[".$val."]]></".$key.">";
		}
	}
	$xml.="</xml>";
	return $xml;
}

/* *
*   Xml转数组
* * * * *
*/
function FromXml($xml){
	if(!$xml){
		echo "xml数据异常！";
	}
	//将XML转为array
	//禁止引用外部xml实体
	libxml_disable_entity_loader(true);
	$data = json_decode(json_encode(simplexml_load_string($xml, 'SimpleXMLElement', LIBXML_NOCDATA)), true);
	return $data;
}

/* *
*   随机字符串
* * * * *
*/
function rand_code(){
	$str = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';//62个字符
	$str = str_shuffle($str);
	$str = substr($str,0,32);
	return $str;
}

/* *
*   获取IP地址
* * * * *
*/
function getIp(){
	$ip=false;
	if(!empty($_SERVER["HTTP_CLIENT_IP"])){
		$ip = $_SERVER["HTTP_CLIENT_IP"];
	}
	if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
		$ips = explode (", ", $_SERVER['HTTP_X_FORWARDED_FOR']);
		if ($ip) { 
			array_unshift($ips, $ip); 
			$ip = FALSE; 
		}
		for ($i = 0; $i < count($ips); $i++) {
			if (!eregi ("^(10│172.16│192.168).", $ips[$i])) {
				$ip = $ips[$i];
				break;
			}
		}
	}
	return ($ip ? $ip : $_SERVER['REMOTE_ADDR']);
}

/* *
*   curl请求
* * * * *
*/
function https_request($url, $data = null) {  
	$curl = curl_init();  
	curl_setopt($curl, CURLOPT_URL, $url);  
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);  
	curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);  
	if (!empty($data)){  
		curl_setopt($curl, CURLOPT_POST, 1);  
		curl_setopt($curl, CURLOPT_POSTFIELDS, $data);  
	}  
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);  
	$output = curl_exec($curl);  
	curl_close($curl);  
	return $output;  
}


?>